/// <reference types="node" />
import * as http from 'http';
import { EventEmitter } from 'events';
import HttpServer from "./httpServer";
import HttpsServer from "./httpsServer";
import { IRequest, IResponse, CertAuthority } from "./models";
declare type AnyContent = IRequest | IResponse;
declare type InterceptHandler = (phase: string, request: IRequest, response: IResponse) => Promise<AnyContent>;
interface PortOptions {
    bridgePort: number;
    httpPort?: number;
    httpsPort?: number;
}
export default class BridgeServer extends EventEmitter {
    bridgeServer: http.Server;
    httpServer: HttpServer;
    httpsServer?: HttpsServer;
    constructor(interceptHandler: InterceptHandler, certAuthority?: CertAuthority);
    private createBridgeServer;
    private forwardErrors;
    private createHttpsBridge;
    listen(port: number | PortOptions): void;
    close(): void;
}
export {};
