"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const pem = __importStar(require("pem"));
const tls = __importStar(require("tls"));
class CertificateHandler {
    constructor(rootCert, rootCertKey) {
        this.rootCert = rootCert.toString('utf8');
        this.rootCertKey = rootCertKey.toString('utf8');
        this.cache = new Map();
    }
    getSecureTlsConnection(serverName, callback) {
        const cachedCertificate = this.cache.get(serverName);
        if (cachedCertificate) {
            callback(null, cachedCertificate);
            return;
        }
        this.createCertificate(serverName, callback);
    }
    createCertificate(serverName, callback) {
        const certificateHandler = (error, result) => {
            if (error) {
                callback(error, { context: {} }); // TODO; REFACTOR THIS RETURN
                return;
            }
            const { certificate, clientKey } = result;
            const secureContext = tls.createSecureContext({ key: clientKey, cert: certificate });
            callback(null, secureContext);
        };
        pem.createCertificate({
            country: 'US',
            state: 'Utah',
            locality: 'Provo',
            organization: 'ACME Tech Inc',
            commonName: serverName,
            altNames: [serverName],
            serviceKey: this.rootCertKey,
            serviceCertificate: this.rootCert,
            serial: Date.now(),
            days: 500,
        }, certificateHandler);
    }
}
exports.default = CertificateHandler;
