/// <reference types="node" />
import { IncomingMessage, IncomingHttpHeaders } from "http";
export declare type HeaderValue = string | string[];
export default class RequestModel {
    httpVersion: string;
    headers: Record<string, HeaderValue>;
    remoteAddress: string;
    size: number;
    body: Buffer;
    get stringBody(): string;
    set stringBody(newBody: string);
    constructor(incomingMessage?: IncomingMessage | undefined);
    protected formattedHeaders(headers: IncomingHttpHeaders): Record<string, HeaderValue>;
    /**
     * Socket connections may be reused. It means that `connection.bytesRead` may have the size
     * from the last executed request. This workarounds calculate the difference from this size
     * to get the size of the specific request/response
     */
    protected calculateSize(incomingMessage: IncomingMessage): number;
}
