/// <reference types="node" />
import { IncomingMessage } from "http";
import RequestModel, { HeaderValue } from "./request-model";
export interface IRequest {
    protocol: string;
    hostname: string;
    method: string;
    url: string;
    query: any;
    headers: Record<string, HeaderValue>;
    body: Buffer;
    remoteAddress: string;
    size: number;
    [key: string]: any;
}
export declare class Request extends RequestModel implements IRequest {
    protocol: string;
    method: string;
    url: string;
    query: any;
    get fullUrl(): string;
    get hostname(): string;
    constructor(httpRequest: IncomingMessage, protocol: string);
}
