/// <reference types="node" />
import { EventEmitter } from 'events';
import { ProxyOptions, IRequest, IResponse } from './models';
interface InterceptOptions {
    phase: Phase;
}
declare type Phase = 'request' | 'response';
declare type AnyContent = IRequest | IResponse;
declare type InterceptHandler = (request: IRequest, response: IResponse) => Promise<AnyContent>;
interface PortOptions {
    bridgePort: number;
    httpPort?: number;
    httpsPort?: number;
}
export declare class Proxy extends EventEmitter {
    private bridgeServer;
    private interceptors;
    constructor(options: ProxyOptions);
    private setupErrorHandling;
    onIntercept(phase: string, request: IRequest, response: IResponse): Promise<IRequest | IResponse>;
    intercept(options: InterceptOptions, handler: InterceptHandler): void;
    listen(port: number | PortOptions): void;
    close(): void;
}
export {};
