"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const http_1 = __importDefault(require("http"));
const https_1 = __importDefault(require("https"));
const proxy_error_1 = __importStar(require("./errors/proxy-error"));
class Router {
    static forward(request, callback) {
        const requestOptions = {
            host: request.hostname,
            port: request.protocol === 'https:' ? 443 : 80,
            path: request.url,
            method: request.method,
            headers: request.headers
        };
        switch (request.protocol) {
            case 'http:': return http_1.default.request(requestOptions, (response) => callback(response));
            case 'https:': return https_1.default.request(requestOptions, (response) => callback(response));
            default:
                throw new proxy_error_1.default(`Unknown protocol ${request.protocol} received by the Router`, proxy_error_1.ErrorType.inconsistency);
        }
    }
}
exports.default = Router;
